denm_layer Class Reference

This class provides description of ITS DENM protocol layer. More...

`#include <denm_layer.hh>`

Inheritance diagram for denm_layer:

## Public Member Functions

| denm_layer ()
| DENM codec. More...
| denm_layer (const std::string &p_type, const std::string &param)
| Specialised constructor Create a new instance of the denm_layer class. More...
virtual | ~denm_layer ()
| Default destructor. More...
void | sendMsg (const LibItsDenm__TestSystem::DenmReq &p_denm_req, Params &params)
| Send DEN message to the lower layers. More...
virtual void | send_data (OCTETSTRING &data, Params &params)
| Send bytes formated data to the lower layers. More...
virtual void | receive_data (OCTETSTRING &data, Params &info)
| Receive bytes formated data from the lower layers. More...
Public Member Functions inherited from t_layer< LibItsDenm__TestSystem::DenmPort >
| t_layer ()
| The list of the upper ports. More...
| t_layer (const std::string &p_type)
| Specialized constructor Create a new instance of the layer class with its type description. More...
void | add_upper_port (LibItsDenm__TestSystem::DenmPort *p_port)
| Add a new upper port layer. More...
void | remove_upper_port (LibItsDenm__TestSystem::DenmPort *)
| Remove the specified upper layer port protocol from the list of the upper layers. More...
Public Member Functions inherited from layer
| layer ()
| Type description, it indicates the protocol type (e.g. CAM, DENM, GN, ETH, PCAP...) More...
| layer (const std::string &p_type)
| Specialized constructor Create a new instance of the layer class with its type description. More...
virtual | ~layer ()
| Default destructor. More...
void | delete_layer ()
| Delete this layer. More...
void | add_upper_layer (layer *p_layer)
| Add a new layer in the list of the upper layer. More...
void | remove_upper_layer (layer *p_layer)
| Remove the specified upper layer protocol from the list of the upper layer. More...
const std::string & | to_string () const
| Remove the specified upper layer protocol from the list of the upper layer. More...

## Private Attributes

Params | _params
DENMCodec | _codec
| Layer parameters. More...

## Additional Inherited Members

Protected Member Functions inherited from t_layer< LibItsDenm__TestSystem::DenmPort >
void | to_all_upper_ports (const TMessage &p_message, const Params &p_params)
| Forward the message to all available upper port layers. More...
Protected Member Functions inherited from layer
void | to_all_layers (std::vector< layer *> &layers, OCTETSTRING &data, Params &params)
void | receive_to_all_layers (OCTETSTRING &data, Params &params)
void | send_to_all_layers (OCTETSTRING &data, Params &params)
Protected Attributes inherited from layer
std::string | type
| List of the lower protocol layers. More...

## Detailed Description

This class provides description of ITS DENM protocol layer.

## Constructor & Destructor Documentation

## denm_layer() [1/2]

denm_layer::denm_layer | ( |  | ) |

inlineexplicit

DENM codec.

Default constructor Create a new instance of the denm_layer class

## denm_layer() [2/2]

denm_layer::denm_layer | ( | const std::string & | p_type,
|  | const std::string & | param
| ) |  |

Specialised constructor Create a new instance of the denm_layer class.

Parameters

  [in] | p_type |

## ~denm_layer()

virtual denm_layer::~denm_layer | ( |  | ) |

inlinevirtual

Default destructor.

## Member Function Documentation

## receive_data()

void denm_layer::receive_data | ( | OCTETSTRING & | data,
|  | Params & | params
| ) |  |

virtual

Receive bytes formated data from the lower layers.

Parameters

  [in] | p_data | The bytes formated data received
  [in] | p_params | Some lower layers parameters values when data was received

Reimplemented from layer.

## send_data()

void denm_layer::send_data | ( | OCTETSTRING & | data,
|  | Params & | params
| ) |  |

virtual

Send bytes formated data to the lower layers.

Parameters

  [in] | p_data | The data to be sent
  [in] | p_params | Some parameters to overwrite default value of the lower layers parameters

Reimplemented from layer.

## sendMsg()

void denm_layer::sendMsg | ( | const LibItsDenm__TestSystem::DenmReq & | p_denm_req,
|  | Params & | p_params
| ) |  |

Send DEN message to the lower layers.

Parameters

  [in] | p_denm_req | The DEN message to be sent
  [in] | p_params | Some parameters to overwrite default value of the lower layers parameters

## Member Data Documentation

## _codec

DENMCodec denm_layer::_codec

private

Layer parameters.

## _params

Params denm_layer::_params

private

The documentation for this class was generated from the following files:

- /home/vagrant/TriesAndDelete/etsi_its/framework/include/denm_layer.hh
- /home/vagrant/TriesAndDelete/etsi_its/framework/src/denm_layer.cc